=== debian/changelog ===
intel-cmt-cat (2.1.0-1) unstable; urgency=medium

  * Sync with upstream 2.1.0

 -- Colin King <colin.king@canonical.com>  Fri, 12 Oct 2018 22:41:11 +0100
