## intel-cmt-cat 3.0.0

=== lib/Makefile ===
--- 
+++ 
@@ -4,7 +4,7 @@
 # @par
 # BSD LICENSE
 #
-# Copyright(c) 2014-2017 Intel Corporation. All rights reserved.
+# Copyright(c) 2014-2019 Intel Corporation. All rights reserved.
 # All rights reserved.
 #
 # Redistribution and use in source and binary forms, with or without
@@ -35,19 +35,22 @@
 ###############################################################################
 
 LIB = libpqos
-VERSION = 2.1.0
-SO_VERSION = 2
+VERSION = 3.0.0
+SO_VERSION = 3
 SHARED ?= y
 LDFLAGS = -L. -lpthread -z noexecstack -z relro -z now
 CFLAGS = -pthread -I./ -D_GNU_SOURCE \
 	-W -Wall -Wextra -Wstrict-prototypes -Wmissing-prototypes \
 	-Wmissing-declarations -Wold-style-definition -Wpointer-arith \
 	-Wcast-qual -Wundef -Wwrite-strings \
-	-Wformat -Wformat-security -fstack-protector -D_FORTIFY_SOURCE=2\
+	-Wformat -Wformat-security -fstack-protector \
 	-Wunreachable-code -Wsign-compare -Wno-endif-labels
 ifneq ($(EXTRA_CFLAGS),)
 CFLAGS += $(EXTRA_CFLAGS)
 endif
+ifneq ($(EXTRA_LDFLAGS),)
+LDFLAGS += $(EXTRA_LDFLAGS)
+endif
 
 DOXY_DIRS = doc_api doc_lib
 
@@ -74,7 +77,7 @@
 ifeq ($(DEBUG),y)
 CFLAGS += -g -ggdb -O0 -DDEBUG
 else
-CFLAGS += -g -O2
+CFLAGS += -g -O2 -D_FORTIFY_SOURCE=2
 endif
 
 # Build targets and dependencies
@@ -86,6 +89,7 @@
 ifeq ($(shell uname), FreeBSD)
 OBJS := $(filter-out perf.o \
 	os_allocation.o \
+	os_cap.o \
 	os_monitoring.o \
 	resctrl.o \
 	resctrl_alloc.o \
@@ -104,7 +108,7 @@
 
 $(LIBNAME): $(OBJS)
 ifeq ($(SHARED),y)
-	$(CC) -shared -Wl,-soname,$(LIB).so.$(SO_VERSION) -o $(LIBNAME) $^ -lc
+	$(CC) $(LDFLAGS) -shared -Wl,-soname,$(LIB).so.$(SO_VERSION) -o $(LIBNAME) $^ -lc
 	ln -f -s $(LIBNAME) $(LIB).so.$(SO_VERSION)
 	ln -f -s $(LIB).so.$(SO_VERSION) $(LIB).so
 else
@@ -192,6 +196,7 @@
 	-f machine.h -f machine.c \
 	-f monitoring.h -f monitoring.c \
 	-f os_allocation.h -f os_allocation.c \
+	-f os_cap.h -f os_cap.c \
 	-f os_monitoring.h os_monitoring.c \
 	-f perf.h -f perf.c \
 	-f perf_monitoring.h -f perf_monitoring.c \
@@ -212,6 +217,7 @@
 	log.c log.h types.h machine.c machine.h \
 	utils.c utils.h \
 	cpuinfo.c cpuinfo.h os_allocation.h os_allocation.c \
+	os_cap.h os_cap.c \
 	os_monitoring.h os_monitoring.c \
 	perf_monitoring.h perf_monitoring.c \
 	resctrl_alloc.h resctrl_alloc.c \
