=== debian/changelog ===
intel-cmt-cat (3.0.0-0ubuntu1) disco; urgency=medium

  * Sync with upstream 3.0.0

 -- Colin King <colin.king@canonical.com>  Tue, 19 Feb 2019 16:51:23 +0000
