## intel-cmt-cat 3.0.1

=== debian/changelog ===
intel-cmt-cat (3.0.1-1) unstable; urgency=medium

  * Sync with upstream 3.0.1

 -- Colin King <colin.king@canonical.com>  Sun, 21 Jul 2019 17:27:24 +0100

intel-cmt-cat (3.0.0-1) unstable; urgency=medium

  * Sync with upstream 3.0.0

 -- Colin King <colin.king@canonical.com>  Tue, 19 Feb 2019 16:51:23 +0000
