## intel-cmt-cat 3.1.1

=== Makefile ===
--- 
+++ 
@@ -4,7 +4,7 @@
 # @par
 # BSD LICENSE
 #
-# Copyright(c) 2014-2016 Intel Corporation. All rights reserved.
+# Copyright(c) 2014-2019 Intel Corporation. All rights reserved.
 # All rights reserved.
 #
 # Redistribution and use in source and binary forms, with or without
@@ -66,6 +66,7 @@
 	$(MAKE) -C examples/c/CAT_MBA clean
 	$(MAKE) -C examples/c/CMT_MBM clean
 	$(MAKE) -C examples/c/PSEUDO_LOCK clean
+	$(MAKE) -C tests clean
 
 style:
 	$(MAKE) -C lib style
@@ -75,6 +76,7 @@
 	$(MAKE) -C examples/c/CAT_MBA style
 	$(MAKE) -C examples/c/CMT_MBM style
 	$(MAKE) -C examples/c/PSEUDO_LOCK style
+	$(MAKE) -C appqos style
 
 cppcheck:
 	$(MAKE) -C lib cppcheck
