=== appqos/requirements.txt ===
pylint
bandit
jsonschema
pexpect
requests
flask
flask_httpauth
flask_restful
pytest
pytest-cov
mock
