=== lib/Makefile ===
--- 
+++ 
@@ -35,7 +35,7 @@
 ###############################################################################
 
 LIB = libpqos
-VERSION = 3.0.0
+VERSION = 3.1.0
 SO_VERSION = 3
 SHARED ?= y
 LDFLAGS = -L. -lpthread -z noexecstack -z relro -z now
@@ -54,12 +54,21 @@
 
 DOXY_DIRS = doc_api doc_lib
 
-# ICC and GCC options
+# ICC and GCC/CLANG options
 ifeq ($(CC),icc)
 else
+# GCC and clang
 CFLAGS += -Wcast-align \
     -Wnested-externs \
     -Wmissing-noreturn
+endif
+
+IS_GCC = $(shell $(CC) -v 2>&1 | grep -c "^gcc version ")
+# GCC-only options
+ifeq ($(IS_GCC),1)
+CFLAGS += -fno-strict-overflow \
+    -fno-delete-null-pointer-checks \
+    -fwrapv
 endif
 
 # so or static build
@@ -94,6 +103,8 @@
 	resctrl.o \
 	resctrl_alloc.o \
 	resctrl_monitoring.o \
+	resctrl_schemata.o \
+	resctrl_utils.o \
 	perf_monitoring.o,$(OBJS))
 endif
 
@@ -174,6 +185,7 @@
 
 clean:
 	-rm -f $(CLEAN_OBJS) $(LIB)* $(DEPFILES)
+	$(MAKE) -C python clean
 
 clobber:
 	-rm -f $(CLEAN_OBJS) $(LIB)* $(DEPFILES)
@@ -186,11 +198,12 @@
 	--ignore CODE_INDENT,INITIALISED_STATIC,LEADING_SPACE,SPLIT_STRING,\
 	NEW_TYPEDEFS,UNSPECIFIED_INT,BLOCK_COMMENT_STYLE,\
 	SPDX_LICENSE_TAG,ARRAY_SIZE,EMBEDDED_FUNCTION_NAME,\
-	SYMBOLIC_PERMS \
+	SYMBOLIC_PERMS,CONST_STRUCT \
 	-f pqos.h \
 	-f allocation.h -f allocation.c \
 	-f api.h -f api.c \
 	-f cap.h -f cap.c \
+	-f common.h -f common.c \
 	-f cpuinfo.h -f cpuinfo.c \
 	-f log.h -f log.c \
 	-f machine.h -f machine.c \
@@ -203,8 +216,11 @@
 	-f resctrl.h -f resctrl.c \
 	-f resctrl_monitoring.h -f resctrl_monitoring.c \
 	-f resctrl_alloc.h -f resctrl_alloc.c \
+	-f resctrl_schemata.h -f resctrl_schemata.c \
+	-f resctrl_utils.h -f resctrl_utils.c \
 	-f types.h \
 	-f utils.h -f utils.c
+	$(MAKE) -C python style
 
 CPPCHECK?=cppcheck
 .PHONY: cppcheck
@@ -212,7 +228,7 @@
 	$(CPPCHECK) \
 	--enable=warning,portability,performance,missingInclude \
 	--std=c99 --template=gcc \
-	api.c api.h cap.c cap.h allocation.c perf.c perf.h \
+	api.c api.h cap.c cap.h common.h common.c allocation.c perf.c perf.h \
 	allocation.h monitoring.c monitoring.h \
 	log.c log.h types.h machine.c machine.h \
 	utils.c utils.h \
@@ -222,7 +238,9 @@
 	perf_monitoring.h perf_monitoring.c \
 	resctrl_alloc.h resctrl_alloc.c \
 	resctrl.h resctrl.c \
-	resctrl_monitoring.h resctrl_monitoring.c
+	resctrl_monitoring.h resctrl_monitoring.c \
+	resctrl_schemata.h resctrl_schemata.c \
+	resctrl_utils.h resctrl_utils.c
 
 # if target not clean or rinse then make dependencies
 ifneq ($(MAKECMDGOALS),clean)
