=== tests/requirements.txt ===
pytest>=3.6.0
pytest-timeout
pexpect
pylint
jsonschema
