=== lib/python/requirements.txt ===
bandit
pylint
coverage
mock
