=== tools/membw/Makefile ===
--- 
+++ 
@@ -4,7 +4,7 @@
 # @par
 # BSD LICENSE
 #
-# Copyright(c) 2018 Intel Corporation. All rights reserved.
+# Copyright(c) 2018-2019 Intel Corporation. All rights reserved.
 # All rights reserved.
 #
 # Redistribution and use in source and binary forms, with or without
@@ -37,22 +37,46 @@
 
 APP = membw
 
-CFLAGS=-Wall -Winline -msse4.2
+CFLAGS=-W -Wall -Wextra -Wstrict-prototypes -Wmissing-prototypes \
+	-Wmissing-declarations -Wold-style-definition -Wpointer-arith \
+	-Wcast-qual -Wundef -Wwrite-strings \
+	-Wformat -Wformat-security -fstack-protector -fPIE \
+	-Wunreachable-code -Wsign-compare -Wno-endif-labels \
+	-Winline -msse4.2
 
 ifeq ($(DEBUG),y)
 CFLAGS += -O0 -g -DDEBUG
 else
-CFLAGS += -O3 -g -mtune=native -march=native
+CFLAGS += -O3 -g -mtune=native -march=native -D_FORTIFY_SOURCE=2
 endif
+
+IS_GCC = $(shell $(CC) -v 2>&1 | grep -c "^gcc version ")
+# GCC-only options
+ifeq ($(IS_GCC),1)
+CFLAGS += -fno-strict-overflow \
+    -fno-delete-null-pointer-checks \
+    -fwrapv
+endif
+
+SRCS = $(sort $(wildcard *.c))
+OBJS = $(SRCS:.c=.o)
+DEPFILES = $(SRCS:.c=.d)
 
 all: $(APP)
 
-$(APP): $(APP).c
+$(APP): $(OBJS)
+	$(CC) $(LDFLAGS) $^ $(LDLIBS) -o $@
+
+%.o: %.c %.d
+
+%.d: %.c
+	$(CC) -MM -MP -MF $@ $(CFLAGS) $<
+	cat $@ | sed 's/$(@:.d=.o)/$@/' >> $@
 
 .PHONY: clean
 
 clean:
-	-rm -f ./*.o ./$(APP)
+	-rm -f $(APP) $(OBJS) $(DEPFILES) ./*~
 
 CHECKPATCH?=checkpatch.pl
 .PHONY: style
@@ -60,10 +84,18 @@
 	$(CHECKPATCH) --no-tree --no-signoff --emacs \
 	--ignore CODE_INDENT,INITIALISED_STATIC,LEADING_SPACE \
 	--ignore SPLIT_STRING,UNSPECIFIED_INT,ARRAY_SIZE,COMPLEX_MACRO \
+	--ignore STORAGE_CLASS,SPDX_LICENSE_TAG,CONST_STRUCT \
 	-f membw.c
 
 CPPCHECK?=cppcheck
 .PHONY: cppcheck
 cppcheck:
-	$(CPPCHECK) enable=warning,portability,performance,missingInclude \
+	$(CPPCHECK) enable=warning,portability,performance,unusedFunction,missingInclude \
 	--std=c99 --template=gcc membw.c
+
+
+# if target not clean then make dependencies
+ifneq ($(MAKECMDGOALS),clean)
+-include $(DEPFILES)
+endif
+
