=== debian/changelog ===
intel-cmt-cat (3.1.1-1) unstable; urgency=medium

  * Sync with upstream 3.1.1

 -- Colin King <colin.king@canonical.com>  Thu, 22 Aug 2019 12:13:14 +0100

intel-cmt-cat (3.1.0-1) unstable; urgency=medium

  * Sync with upstream 3.1.0
    - refresh Makefile debian/patches

 -- Colin King <colin.king@canonical.com>  Fri, 16 Aug 2019 13:03:22 +0100

intel-cmt-cat (3.0.1-3) unstable; urgency=medium

  * Remove build of example binaries
    - we don't install these so just skip building these too

 -- Colin King <colin.king@canonical.com>  Thu, 15 Aug 2019 10:52:15 +0100

intel-cmt-cat (3.0.1-2) unstable; urgency=medium

  * Update compat level to 12

 -- Colin King <colin.king@canonical.com>  Mon, 12 Aug 2019 19:58:22 +0100
